// Apply Below
// Paulo Ricardo Reinehr
// PS 2.0
// Allows to apply effects to every pixel below it. All preceding effects in the stack will be ignored. If applied to a layer make sure to turn off 'Transparent' on layer properties.


// Foreground texture
texture ForegroundTexture;

// Background texture
texture BackgroundTexture;


// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

// OriginalTexture sampler
sampler2D background = sampler_state {
    Texture = (BackgroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};


// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{

	float4 alpha = tex2D(foreground, Tex.xy);
	float4 color = tex2D( background, Tex.xy );

	color.a = alpha.a ;

	return color ;

}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
