// Colour Mask
// Somebody (Thanks to Shviller and Rojohound)
// PS 2.0
// Mask RGB colour (make transparent)

//#PARAM float maskr 0 : Mask R : Red component of the colour to mask.
//#PARAM float maskg 0 : Mask G : Green component of the colour to mask.
//#PARAM float maskb 0 : Mask B : Blue component of the colour to mask.
//#PARAM percent masko 0 : Opacity : How transparent the masked part is.

float maskr;
float maskg;
float maskb;
float masko;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state
{
  Texture = (ForegroundTexture);
  MinFilter = Point;
  MagFilter = Point;
  MipFilter = Point;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
	float4 front = tex2D(foreground, Tex.xy);
		front.rgb /= front.a;
		if(front.r == maskr/255 && front.g == maskg/255 && front.b == maskb/255) { front.a *= masko; }
		front.rgb *= front.a;
	return front;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}
